//
//  Accumulator.m
//  UpTop
//
//  Created by Geoff Prewett on 11/19/16.
//  Copyright © 2016 Geoff Prewett. All rights reserved.
//

#import "Accumulator.h"

@interface Accumulator ()
@property int maxCount;
@property int currentIdx;
@end

@implementation Accumulator
- (instancetype)initWithSize:(unsigned int)size
{
    self = [super init];
    if (self) {
        self.maxCount = size;
        self.data = [[NSMutableArray alloc] initWithCapacity:size];
        self.currentIdx = -1;
    }
    return self;
}

- (void)addObject:(id)o
{
    if (self.data.count < self.maxCount) {
        [self.data addObject:o];
        self.currentIdx += 1;
    } else {
        self.currentIdx = (self.currentIdx + 1) % self.maxCount;
        [self.data setObject:o atIndexedSubscript:self.currentIdx];
    }
}

- (id)newest
{
    return [self.data objectAtIndex:self.currentIdx];
}

- (id)oldest
{
    if (self.data.count == self.maxCount) {
        return [self.data objectAtIndex:((self.currentIdx - 1) % self.maxCount)];
    } else {
        return [self.data objectAtIndex:0];
    }
}
@end
