//
//  Settings.h
//  UpTop
//
//  Created by Geoff Prewett on 11/14/16.
//  Copyright © 2016 Geoff Prewett. All rights reserved.
//

#import <Cocoa/Cocoa.h>

typedef enum { kLocUpperRight = 0, kLocMiddleRight, kLocLowerRight,
               kLocUpperLeft, kLocMiddleLeft, kLocLowerLeft,
               kLocMoveable }
             Location;

@interface Settings : NSObject

+ (double)refreshDelaySec;
+ (int)diskIOAccumulatorLength;
+ (Location)windowLocation;
+ (NSRect)windowRect;  // only valid if windowLocation is kLocMoveable
+ (NSColor*)foregroundColor;
+ (NSColor*)wiredMemoryColor;
+ (NSColor*)compressedMemoryColor;
+ (NSColor*)appMemoryColor;
+ (NSColor*)swapColor;
+ (NSColor*)systemCPUColor;
+ (NSColor*)userCPUColor;
+ (NSFont*)font;
+ (int)nMemoryLines;
+ (int)nCPULines;
+ (int)nDiskIOLines;
+ (BOOL)showSwap;
+ (BOOL)showLocalizedProcessNames;

+ (void)setDefaultRefreshDelay:(double)sec;
+ (void)setDefaultPosition:(Location)loc;
+ (void)setDefaultWindowRect:(NSRect)r;
+ (void)setDefaultMemoryColors:(NSColor*)wired compressed:(NSColor*)compressed app:(NSColor*)app swap:(NSColor*)swap;
+ (void)setDefaultCPUColors:(NSColor*)system user:(NSColor*)user;
+ (void)setDefaultFontName:(NSString*)fontName size:(CGFloat)fontSize;
+ (void)setDefaultNMemoryLines:(int)nLines;
+ (void)setDefaultNCPULines:(int)nLines;
+ (void)setDefaultNDiskIOLines:(int)nLines;
+ (void)setShowSwap:(BOOL)show;
+ (void)setDefaultDiskIOAccumulatorLength:(int)n;
+ (void)setShowLocalizedProcessNames:(BOOL)show;

+ (void)resetToDefault;

@end
