#!/bin/bash

name=UpTop
createDMG=~/bin/create-dmg/create-dmg
destPath=${name}.dmg

# Find the most recent archived version.
# -print0 causes find to end a string with a null, which xargs -0 uses.  This
#    is necessary because the path will have a space in it >(
contentsDir=`find ~/Library/Developer -name ${name}.app -print0 | xargs -0 ls -dt | head -1`
echo "Using archived ${name}.app from: "`stat -f "%Sm" "$contentsDir"`
appIcon="$contentsDir"/Contents/Resources/AppIcon.icns
contentsDir=`dirname "$contentsDir"`

rm -rf $destPath
$createDMG --volname $name \
		   --volicon "$appIcon" \
		   --background dmg-background.png \
		   --window-size 640 480 \
		   --icon-size 64 \
		   --text-size 12 \
		   --icon UpTop.app 192 392 \
		   --app-drop-link 448 392 \
		   $destPath \
		   "$contentsDir"

